<template>
  <div
    id="app-sidebar"
    class="bg-blue-600 h-screen hidden lg:block flex-shrink-0 absolute lg:static left-0 top-0 z-1 select-none"
    style="width: 280px"
  >
    <div class="flex flex-column h-full">
      <div class="flex align-items-center px-5 bg-bluegray-900 flex-shrink-0 text-bluegray-100" style="height: 60px">
        <span class="font-medium">ATK Self-Reporting</span>
      </div>

      <div class="overflow-y-auto mt-3">
        <ul class="list-none p-3 m-0">
          <li v-for="link in links" :key="link.path">
            <a
              :href="link.path"
              v-ripple
              :class="[
                'flex align-items-center cursor-pointer p-3 hover:bg-bluegray-900 border-round text-bluegray-100 transition-duration-150 transition-colors p-ripple',
                { 'bg-bluegray-600': link.path === router.path },
              ]"
            >
              <i :class="link.icon" class="mr-2"></i>
              <span class="font-medium">{{ link.label }}</span>
            </a>
          </li>
        </ul>
      </div>

      <div class="mt-auto" v-if="isLoggedIn">
        <hr class="mb-3 mx-3 border-top-1 border-none border-blue-50" />
        <ul class="list-none p-2 m-0 hidden origin-bottom animation-duration-150 overflow-hidden animation-ease-in-out">
          <li>
            <a
              v-ripple
              @click="signOut"
              class="flex align-items-center cursor-pointer p-3 hover:bg-bluegray-900 border-round text-bluegray-100 hover:text-bluegray-50 transition-duration-150 transition-colors p-ripple"
            >
              <i class="pi pi-sign-out mr-2"></i>
              <span class="font-medium">Sign Out</span>
            </a>
          </li>
        </ul>
        <a
          v-ripple
          class="m-3 px-3 py-2 flex align-items-center hover:bg-bluegray-900 border-round cursor-pointer text-bluegray-100 hover:text-bluegray-50 transition-duration-150 transition-colors p-ripple"
          v-styleclass="{
            selector: '@prev',
            enterClass: 'hidden',
            enterActiveClass: 'slidedown',
            leaveToClass: 'hidden',
            leaveActiveClass: 'slideup',
          }"
        >
          <i class="pi pi-user mr-2"></i>
          <span class="font-medium">{{ userData.user.name }}</span>
          <i class="pi pi-chevron-up ml-auto"></i>
        </a>
      </div>
      <div class="mt-auto" v-else>
        <hr class="mb-3 mx-3 border-top-1 border-none border-blue-50" />
        <a
          :href="'/login'"
          class="m-3 px-3 py-2 flex align-items-center hover:bg-bluegray-900 border-round cursor-pointer text-bluegray-100 hover:text-bluegray-50 transition-duration-150 transition-colors p-ripple"
        >
          <i class="pi pi-sign-in mr-2"></i>
          <span class="font-medium">Login</span>
        </a>
      </div>
    </div>
  </div>

  <div
    class="fixed flex justify-content-between align-items-center px-3 surface-0 surface-border lg:static"
    style="height: 60px"
  >
    <div class="flex">
      <a
        v-ripple
        class="cursor-pointer block lg:hidden text-700 mr-3 mt-1 p-ripple"
        v-styleclass="{
          selector: '#app-sidebar',
          enterClass: 'hidden',
          enterActiveClass: 'fadeinleft',
          leaveToClass: 'hidden',
          leaveActiveClass: 'fadeoutleft',
          hideOnOutsideClick: true,
        }"
      >
        <i class="pi pi-bars text-4xl"></i>
      </a>
    </div>
  </div>
</template>

<script setup>
import { useRouter } from 'vue-router';
import { useUserStore } from '@/stores/userStore';
import { storeToRefs } from 'pinia';

const router = useRouter();
const userStore = useUserStore();
const { userData, isLoggedIn } = storeToRefs(userStore);

const links = [
  { path: '/', label: 'Main page', icon: 'pi pi-home' },
  { path: '/upload', label: 'ATK Upload', icon: 'pi pi-upload' },
  { path: '/status', label: 'Status', icon: 'pi pi-heart' },
];

const signOut = () => {
  userStore.logout();
  router.push('/');
};
</script>

<style></style>
